const fitWords = () => {
  textFit(document.getElementsByClassName("month__word"), {
    alignHoriz: true,
    alignVert: true,
    maxFontSize: 40
  });
};

const updateWords = (elements, words) => {
  [...elements].forEach((e, i) => {
    e.innerText = words[i];
  });
  fitWords();
};

const wordFinished = evt => {
  const monthWords = document.getElementsByClassName("month__word");
  const currentLSYear =
    window.localStorage.year && JSON.parse(window.localStorage.year);
  const monthName = evt.target.parentElement.children[1].innerText.toLowerCase();
  const monthIndex = [
    ...evt.target.parentElement.parentElement.children
  ].indexOf(evt.target.parentElement);
  const word = evt.target.innerText;
  let year = {};
  if (currentLSYear) {
    year = { ...currentLSYear, [monthIndex]: word };
  } else {
    for (let i = 0; i < 12; i++) year[i] = "...";

    year[monthIndex] = word;
  }

  window.localStorage.setItem("year", JSON.stringify(year));
  updateWords(monthWords, year);
};
const clearMonth = evt => {
  evt.target.innerText = "";
};
const addListeners = () => {
  const monthWords = document.getElementsByClassName("month__word");
  Array.from(monthWords).forEach(e => {
    e.addEventListener("input", fitWords);
    e.addEventListener("focus", clearMonth);
    e.addEventListener("focusout", wordFinished);
  });
};

const initialize = () => {
  const monthWords = document.getElementsByClassName("month__word");
  const currentLSYear =
    window.localStorage.year && JSON.parse(window.localStorage.year);

  if (currentLSYear) {
    updateWords(monthWords, currentLSYear);
  } else {
    fitWords();
  }

  addListeners();
};

window.addEventListener("load", initialize);
window.addEventListener("resize", fitWords);